/*******************************************************************
**
** HyperBase was designed and implemented by:
**
**	Uffe Kock Wiil 		(kock@iesd.auc.dk)
**	Claus Bo Nielsen 	(cbn@cci.dk)
**	Carsten Ruseng Jakobsen (ruseng@sun.com)
**	Finn Soelvsten
**	Per Magnus Petersen
**	Poul Larsen
**	Hans Mejdahl Jeppesen
**
** at The University of Aalborg in Denmark autumn 1989, and is provided
** for unrestricted use provided that this legend is included on all
** tape media and as a part of the software program in whole or part.
** Users may copy or modify HyperBase without charge, but are not
** authorized to license or distribute it to anyone else except as part
** of a product or program developed by the user.
**  
** HyperBase IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING
** THE WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A
** PARTICULAR PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR
** TRADE PRACTICE.
**  
** HyperBase is provided with no support and without any obligation on
** the part of the authors, to assist in its use, correction,
** modification or enhancement.
** 
** THE AUTHORS SHALL HAVE NO LIABILITY WITH RESPECT TO THE INFRINGEMENT
** OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY HyperBase OR ANY PART
** THEREOF.
** 
** In no event will the authors and/or The University of Aalborg be
** liable for any lost revenue or profits or other special, indirect and
** consequential damages, even if the authors and/or The University of
** Aalborg has been advised of the possibility of such damages.
** 
** Please address all correspondence to:
** 
** Uffe Kock Wiil
** Department of Computer Science,
** The University of Aalborg,      Email:  kock@iesd.auc.dk
** Fredrik Bajers Vej 7E,          Phone:  + 45 98 15 42 11 (Ext 5051)
** DK-9220 Aalborg, Denmark.       Fax:    + 45 98 15 81 29
**
*******************************************************************/

/*******************************************************************
** Global definitions
*******************************************************************/

#define END              -1
#define LOCKED           350
#define LOCK_BY_OTHER    351
#define NOT_LOCKED       352
#define NOT_ALL_NODES    353
#define WRONG_NODE       354
#define WRONG_OPERATION  355
#define WRONG_KEY        356


#define OK                0
#define ALL               0
#define NULL              0
#define FALSE             0
#define TRUE              1

#define NODE              1
#define LINK              7
#define USER              11
#define NO_OF_KEYS        USER+NO_OF_USER_DATA_KEYS+NO_OF_USER_LINK_KEYS

#define NL                -1

/*******************************************************************
** Struct for use in Locks Tree's
*******************************************************************/

struct Lock 
{
  int Keys[NO_OF_KEYS];
};

/*******************************************************************
** Class for Lock Tree's
*******************************************************************/

class LockClass : baltree {
public:
  int insert(long n, Lock* a) 	   	{ return baltree::insert(n,a); }
  int remove(long n)			{ return baltree::remove(n); }
  Lock* search(long n)                  { return (Lock*)baltree::search(n); }
  int clear()				{ return baltree::clear(); }
  void inorder()			{ baltree::inorder(); }
  void preorder()			{ baltree::preorder(); }
  long first()                          { return (long)baltree::first();}
  long next(long n)			{ return (long)baltree::next(n);}

  LockClass()    			{ }
  LockClass(long n, Lock* a) : (n,a) 	{ }
};





